﻿namespace TestLibrary
{
    /// <summary>
    /// 수평 정렬
    /// </summary>
    public enum HorizontalAlignment
    {
        /// <summary>
        /// 해당 무
        /// </summary>
        None = 0,

        /// <summary>
        /// 왼쪽
        /// </summary>
        Left,

        /// <summary>
        /// 오른쪽
        /// </summary>
        Right,

        /// <summary>
        /// 가운데
        /// </summary>
        Center,

        /// <summary>
        /// 맞춤 정렬
        /// </summary>
        FullyJustify,

        /// <summary>
        /// 분산
        /// </summary>
        Distributed
    }
}