﻿namespace TestLibrary
{
    /// <summary>
    /// 투인원 스타일
    /// </summary>
    /// <remarks>
    /// 투인원 스타일 인용 기호의 유형 (극동 문자 서식의 경우)
    /// </remarks>
    public enum TwoInOneStyle
    {
        /// <summary>
        /// 비활성화
        /// </summary>
        Disabled = 0,

        /// <summary>
        /// 해당무
        /// </summary>
        None,

        /// <summary>
        /// 괄호
        /// </summary>
        Parentheses,

        /// <summary>
        /// 대괄호
        /// </summary>
        SquareBrackets,

        /// <summary>
        /// 앵글 브래킷
        /// </summary>
        AngledBrackets,

        /// <summary>
        /// 브레이스
        /// </summary>
        Braces
    }
}