namespace TestLibrary
{
    /// <summary>
    /// RTF 
    /// </summary>
    /// <remarks>
    /// RTFBlock ٸ      ̴.
    ///  , ̹ ٸ ̹, ܶ, ̺   ٸ       RTFBlock̴.
    /// </remarks>
    public abstract class RTFBlock : RTFRenderable
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Property
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region   - HorizontalAlignment

        /// <summary>
        ///  
        /// </summary>
        public abstract HorizontalAlignment HorizontalAlignment { get; set; }

        #endregion
        #region  - Margins

        /// <summary>
        /// 
        /// </summary>
        public abstract Margins Margins { get; }

        #endregion
        #region Ʈ   - DefaultCharFormat

        /// <summary>
        /// Ʈ  
        /// </summary>
        public abstract RTFCharFormat DefaultCharFormat { get; }

        #endregion
        #region     - StartNewPage

        /// <summary>
        ///    
        /// </summary>
        /// <remarks>true ϸ      κп ĵȴ.</remarks>
        public abstract bool StartNewPage { get; set; }

        #endregion
        #region   - BlockHead

        /// <summary>
        ///  
        /// </summary>
        /// <remarks> Ͽ   RTF  ܾ</remarks>
        internal abstract string BlockHead { set; }

        #endregion
        #region   - BlockTail

        /// <summary>
        ///  
        /// </summary>
        internal abstract string BlockTail { set; }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Protected

        #region  ڵ ϱ - GetAlignmentCode()

        /// <summary>
        ///  ڵ ϱ
        /// </summary>
        /// <returns> ڵ</returns>
        protected string GetAlignmentCode()
        {
            switch(HorizontalAlignment)
            {
                case HorizontalAlignment.Left         : return @"\ql";
                case HorizontalAlignment.Right        : return @"\qr";
                case HorizontalAlignment.Center       : return @"\qc";
                case HorizontalAlignment.FullyJustify : return @"\qj";
                default                               : return @"\qd";
            }
        }

        #endregion
    }
}