using System;
using System.Text;

namespace TestLibrary
{
    /// <summary>
    /// RTF ƿƼ
    /// </summary>
    public static class RTFUtility
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Static
        //////////////////////////////////////////////////////////////////////////////// Public

        #region и͡Ʈ ȯϱ - ConvertMilimeterToPoint(mm)

        /// <summary>
        /// и͡Ʈ ȯϱ
        /// </summary>
        /// <param name="mm">и </param>
        /// <returns>Ʈ </returns>
        public static float ConvertMilimeterToPoint(float mm)
        {
            return mm * (float) 2.836;
        }

        #endregion
        #region и͡Ʈ ȯϱ - ConvertMilimeterToTwip(mm)

        /// <summary>
        /// и͡Ʈ ȯϱ
        /// </summary>
        /// <param name="mm">и </param>
        /// <returns>Ʈ </returns>
        public static int ConvertMilimeterToTwip(float mm)
        {
            double inches = mm * 0.0393700787;

            return Convert.ToInt32(inches * 1440);
        }

        #endregion
        #region ƮƮ ȯϱ - ConvertPointToTwip(points)

        /// <summary>
        /// ƮƮ ȯϱ
        /// </summary>
        /// <param name="points">Ʈ </param>
        /// <returns>Ʈ </returns>
        public static int ConvertPointToTwip(float points)
        {
            return !float.IsNaN(points) ? Convert.ToInt32(points * 20) : 0;
        }

        #endregion
        #region 2  - DoubleValue(points)

        /// <summary>
        /// 2 
        /// </summary>
        /// <param name="points">Ʈ </param>
        /// <returns>2 Ʈ </returns>
        public static int DoubleValue(float points)
        {
            return Convert.ToInt32(points * 2);
        }

        #endregion
        #region  ʺ ϱ ( : Ʈ) - GetPaperWidthInTwip(paperSize, paperOrientation)

        /// <summary>
        ///  ʺ ϱ ( : Ʈ)
        /// </summary>
        /// <param name="paperSize"> ũ</param>
        /// <param name="paperOrientation"> </param>
        /// <returns> ʺ ( : Ʈ)</returns>
        public static int GetPaperWidthInTwip(PaperSize paperSize, PaperOrientation paperOrientation)
        {
            int[] dimensionArray = GetPaperDimensionArray(paperSize);

            if(paperOrientation == PaperOrientation.Portrait)
            {
                if(dimensionArray[0] < dimensionArray[1])
                {
                    return dimensionArray[0];
                }
                else
                {
                    return dimensionArray[1];
                }
            }
            else
            {
                if(dimensionArray[0] < dimensionArray[1])
                {
                    return dimensionArray[1];
                }
                else
                {
                    return dimensionArray[0];
                }
            }
        }

        #endregion
        #region   ϱ ( : Ʈ) - GetPaperHeightInTwip(paperSize, paperOrientation)

        /// <summary>
        ///   ϱ ( : Ʈ)
        /// </summary>
        /// <param name="paperSize"> ũ</param>
        /// <param name="paperOrientation"> </param>
        /// <returns>  ( : Ʈ)</returns>
        public static int GetPaperHeightInTwip(PaperSize paperSize, PaperOrientation paperOrientation)
        {
            int[] dimensionArray = GetPaperDimensionArray(paperSize);

            if(paperOrientation == PaperOrientation.Portrait)
            {
                if(dimensionArray[0] < dimensionArray[1])
                {
                    return dimensionArray[1];
                }
                else
                {
                    return dimensionArray[0];
                }
            }
            else
            {
                if(dimensionArray[0] < dimensionArray[1])
                {
                    return dimensionArray[0];
                }
                else
                {
                    return dimensionArray[1];
                }
            }
        }

        #endregion
        #region  ʺ ϱ ( : Ʈ) - GetPaperWidthInPoint(paperSize, paperOrientation)

        /// <summary>
        ///  ʺ ϱ ( : Ʈ)
        /// </summary>
        /// <param name="paperSize"> ũ</param>
        /// <param name="paperOrientation"> </param>
        /// <returns> ʺ ( : Ʈ)</returns>
        public static float GetPaperWidthInPoint(PaperSize paperSize, PaperOrientation paperOrientation)
        {
            return (float) GetPaperWidthInTwip(paperSize, paperOrientation) / 20.0f;
        }

        #endregion
        #region   ϱ ( : Ʈ) - GetPaperHeightInPoint(paperSize, paperOrientation)

        /// <summary>
        ///   ϱ ( : Ʈ)
        /// </summary>
        /// <param name="paperSize"> ũ</param>
        /// <param name="paperOrientation"> </param>
        /// <returns>  ( : Ʈ)</returns>
        public static float GetPaperHeightInPoint(PaperSize paperSize, PaperOrientation paperOrientation)
        {
            return (float)GetPaperHeightInTwip(paperSize, paperOrientation) / 20.0f;
        }

        #endregion
        #region ڵ ڵ ȯϱ - ConvertToUnicodeEncoding(source)

        /// <summary>
        /// ڵ ڵ ȯϱ
        /// </summary>
        /// <param name="source">ҽ ڿ</param>
        /// <returns>ڵ ڵ ȯ ڿ</returns>
        public static string ConvertToUnicodeEncoding(string source)
        {
            StringBuilder stringBuilder = new StringBuilder();

            int unicode;

            for(int i = 0; i < source.Length; i++)
            {
                unicode = (int)source[i];

                if(source[i] == '\n')
                {
                    stringBuilder.AppendLine(@"\line");
                }
                else if(source[i] == '\r')
                {
                }
                else if(source[i] == '\t')
                {
                    stringBuilder.Append(@"\tab ");
                }
                else if(unicode <= 0xff)
                {
                    if(unicode == 0x5c || unicode == 0x7b || unicode == 0x7d)
                    {
                        stringBuilder.Append(@"\'" + string.Format("{0:x2}", unicode));
                    }
                    else if(0x00 <= unicode && unicode < 0x20)
                    {
                        stringBuilder.Append(@"\'" + string.Format("{0:x2}", unicode));
                    }
                    else if(0x20 <= unicode && unicode < 0x80)
                    {
                        stringBuilder.Append(source[i]);
                    }
                    else
                    {
                        stringBuilder.Append(@"\'" + string.Format("{0:x2}", unicode));
                    }
                }
                else if(0xff < unicode && unicode <= 0x8000)
                {
                    stringBuilder.Append(@"\uc1\u" + unicode + "*");
                }
                else if(0x8000 < unicode && unicode <= 0xffff)
                {
                    stringBuilder.Append(@"\uc1\u" + (unicode - 0x10000) + "*");
                }
                else
                {
                    stringBuilder.Append(@"\uc1\u9633*");
                }
            }

            return stringBuilder.ToString();
        }

        #endregion
        #region 5 ڵ ȯϱ - ConvertToBig5Encoding(source)

        /// <summary>
        /// 5 ڵ ȯϱ
        /// </summary>
        /// <param name="source">ҽ ڿ</param>
        /// <returns>5 ڵ ȯ ڿ</returns>
        public static string ConvertToBig5Encoding(string source)
        {
            string result = string.Empty;

            Encoding big5Encoding  = Encoding.GetEncoding(950);
            Encoding asciiEncoding = Encoding.ASCII;

            byte[] byteArray = big5Encoding.GetBytes(source);
            byte   character;

            for(int i = 0; i < byteArray.Length; i++)
            {
                character = byteArray[i];

                if
                (
                    (0x00 <= character && character <  0x20) ||
                    (0x80 <= character && character <= 0xff) ||
                    character == 0x5c                        ||
                    character == 0x7b                        ||
                    character == 0x7d
                )
                {
                    result += string.Format(@"\'{0:x2}", character);
                }
                else
                {
                    result += asciiEncoding.GetChars(new byte[] { character })[0];
                }
            }

            return result;
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////// Private

        #region   迭 ϱ - GetPaperDimensionArray(paperSize)

        /// <summary>
        ///   迭 ϱ
        /// </summary>
        /// <param name="paperSize"> ũ</param>
        /// <returns>  迭</returns>
        private static int[] GetPaperDimensionArray(PaperSize paperSize)
        {
            switch(paperSize)
            {
                case PaperSize.Letter : return new int[] { 15840, 12240 };
                case PaperSize.A3     : return new int[] { 16838, 23811 };
                case PaperSize.A4     : return new int[] { 11906, 16838 };
                default               : throw new Exception("Unknow paper size.");
            }
        }

        #endregion
    }
}