﻿namespace TestLibrary
{
    /// <summary>
    /// 폰트 스타일 플래그
    /// </summary>
    public enum FontStyleFlag
    {
        /// <summary>
        /// 볼드체
        /// </summary>
        Bold = 0x01,

        /// <summary>
        /// 이탤릭체
        /// </summary>
        Italic = 0x02,

        /// <summary>
        /// 밑줄
        /// </summary>
        Underline = 0x04,

        /// <summary>
        /// 위 첨자
        /// </summary>
        Super = 0x08,

        /// <summary>
        /// 아래 첨자
        /// </summary>
        Sub = 0x10,

        /// <summary>
        /// 작은 대문자
        /// </summary>
        Scaps = 0x20,

        /// <summary>
        /// 취소선
        /// </summary>
        Strike = 0x40
    }
}