﻿namespace TestLibrary
{
    /// <summary>
    /// 지역 유형
    /// </summary>
    public enum LCID
    {
        /// <summary>
        /// 중국어 번체
        /// </summary>
        TraditionalChinese = 1028,

        /// <summary>
        /// 영어
        /// </summary>
        English = 1033,

        /// <summary>
        /// 프랑스어
        /// </summary>
        French = 1036,

        /// <summary>
        /// 독일어
        /// </summary>
        German = 1031,

        /// <summary>
        /// 이탈리아어
        /// </summary>
        Italian = 1040,

        /// <summary>
        /// 일본어
        /// </summary>
        Japanese = 1041,

        /// <summary>
        /// 한국어
        /// </summary>
        Korean = 1042,

        /// <summary>
        /// 중국어 간체
        /// </summary>
        SimplifiedChinese = 2052,

        /// <summary>
        /// 스페인어
        /// </summary>
        Spanish = 3082
    }
}