using System;
using System.Text;

namespace TestLibrary
{
    /// <summary>
    /// RTF  ٴڱ
    /// </summary>
    public class RTFSectionFooter : RTFBlockList
    {
        //////////////////////////////////////////////////////////////////////////////////////////////////// Constructor
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region  - RTFSectionFooter(parentSection)

        /// <summary>
        /// 
        /// </summary>
        /// <param name="parentSection">θ </param>
        internal RTFSectionFooter(RTFSection parentSection) : base(true, true, true, true, true)
        {
            if(parentSection == null)
            {
                throw new Exception("Section footer can only be placed within a section ");
            }
        }

        #endregion

        //////////////////////////////////////////////////////////////////////////////////////////////////// Method
        ////////////////////////////////////////////////////////////////////////////////////////// Public

        #region ϱ - Render()

        /// <summary>
        /// ϱ
        /// </summary>
        /// <returns>RTF ڿ</returns>
        public override string Render()
        {
            StringBuilder stringBuilder = new StringBuilder();

            stringBuilder.AppendLine(@"{\footerr \ltrpar \pard\plain");
            stringBuilder.AppendLine(@"\par ");
            stringBuilder.Append(base.Render());
            stringBuilder.AppendLine(@"\par");
            stringBuilder.AppendLine(@"}");

            return stringBuilder.ToString();
        }

        #endregion
    }
}